Last Comment Bug 157554 - Failure to instantiate plugin in nsPluginStreamListenerPeer::OnStartRequest does not cause us to layout alternate renderings
: Failure to instantiate plugin in nsPluginStreamListenerPeer::OnStartRequest d...
Status: RESOLVED FIXED
[PL2:P2]
:
Product: Core
Classification: Components
Component: Plug-ins (show other bugs)
: Trunk
: All All
: P2 normal with 6 votes (vote)
: mozilla17
Assigned To: John Schoenick [:johns]
:
: Benjamin Smedberg [:bsmedberg]
Mentors:
: 156199 157150 175465 (view as bug list)
Depends on: 1156 745030
Blocks: 96579 108946 109082 230471
  Show dependency treegraph
 
Reported: 2002-07-15 09:54 PDT by Peter Lubczynski
Modified: 2014-04-26 03:11 PDT (History)
11 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Peter Lubczynski 2002-07-15 09:54:31 PDT
Sometimes plugin code needs to open the stream of an OBJECT (or EMBED) tag in
order to find out the mime-type to use. We do not handle failure here gracefully.

For example:

<object data="missing.file" width=100 height=100>
  Alternate Rendering
</object>

This fails becuase layout never gets a call to CantRenderReplaceElement in
OnStartRequest.

Another similar case that fails is when we are only able to determine the
mime-type from the HTTP header and it's not a handled by a plugin, we never give
layout a chance to see if it can handle it. 

For example:
<object data="http://www.mozilla.org/ width=100 height=100></object>

This fails because a new child nsFrameFrame or nsImageFrame are not created in
OnStartRequest.

I'm investigating on ways to fix this. Calling back into layout for replacement
probably isn't a problem. However, we need to ensure we do not make two requests
when trafering control to the IFRAME or IMG tag code.
Comment 1 Peter Lubczynski 2002-07-15 10:02:52 PDT
Since this is sort of serious and I have sort of an idea of how to fix it now,
lets try to get this done in the near-term....of course if plugins move to
content in bug 90268, this bug would be a good learning experience :)
Comment 2 Peter Lubczynski 2002-07-19 15:18:14 PDT
*** Bug 156199 has been marked as a duplicate of this bug. ***
Comment 3 Peter Lubczynski 2002-07-19 15:19:27 PDT
*** Bug 157150 has been marked as a duplicate of this bug. ***
Comment 4 rubydoo123 2002-12-10 16:53:08 PST
1.3 beta
Comment 5 Peter Lubczynski 2003-02-25 16:23:19 PST
*** Bug 175465 has been marked as a duplicate of this bug. ***
Comment 6 John Schoenick [:johns] 2012-05-11 15:31:26 PDT
bug 745030 should either fix this or make it a much simpler fix
Comment 7 John Schoenick [:johns] 2012-08-07 17:24:08 PDT
This was fully fixed by 745030, although most cases of it had been fixed previously.

Note You need to log in before you can comment on or make changes to this bug.